<script setup lang="ts">
import { computed, onBeforeMount, reactive } from "vue";
import { BucketType } from "@/client/types.gen";
import type { BucketOut, UserOut } from "@/client/types.gen";
import SearchUserModal from "@/components/modals/SearchUserModal.vue";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import { useBucketStore } from "@/stores/buckets";
import { useNameStore } from "@/stores/names";
import { filesize } from "filesize";
import dayjs from "dayjs";
import UpdateBucketLimitsModal from "@/components/admin/UpdateBucketLimitsModal.vue";
import DeleteBucketModal from "@/components/object-storage/modals/DeleteBucketModal.vue";
import CreateOtrModal from "@/components/modals/CreateOtrModal.vue";
import { useRoute, useRouter } from "vue-router";
import { useUserStore } from "@/stores";

const filters = reactive<{
  searchString: string;
  ownerId: string;
}>({
  searchString: "",
  ownerId: "",
});

const bucketState = reactive<{
  buckets: BucketOut[];
  selectedBucket?: BucketOut;
  loading: boolean;
  searched: boolean;
  updateLimitsBucket: BucketOut;
}>({
  buckets: [],
  selectedBucket: undefined,
  loading: false,
  searched: false,
  updateLimitsBucket: {
    name: "",
    description: "",
    owner_id: "",
    public: false,
    created_at: 0,
  },
});

const QUERY_PARAM_OWNER_ID = "owner_id";
const QUERY_PARAM_BUCKET_NAME = "search";

const route = useRoute<"admin-buckets">();
const router = useRouter();

const bucketRepository = useBucketStore();
const nameRepository = useNameStore();
const userRepository = useUserStore();

const updateLimitsModalId = "admin-update-bucket-limits-modal";

const filteredBuckets = computed<BucketOut[]>(() =>
  bucketState.buckets.filter((bucket) =>
    bucket.name.includes(filters.searchString),
  ),
);

function updateUser(user: UserOut) {
  filters.ownerId = user.uid;
}

function resetForm() {
  filters.ownerId = "";
  filters.searchString = "";
  bucketState.buckets = [];
  bucketState.searched = false;
  router.replace({ name: "admin-buckets" });
}

function searchBuckets() {
  bucketState.loading = true;
  bucketRepository
    .fetchBuckets(filters.ownerId ? filters.ownerId : undefined, BucketType.OWN)
    .then((buckets) => {
      bucketState.buckets = buckets;
    })
    .finally(() => {
      bucketState.loading = false;
      bucketState.searched = true;
    });
  const queryParams: Record<string, string> = {};
  if (filters.ownerId.length > 0) {
    queryParams[QUERY_PARAM_OWNER_ID] = filters.ownerId;
  }
  if (filters.searchString.trim().length > 0) {
    queryParams[QUERY_PARAM_BUCKET_NAME] = filters.searchString.trim();
  }
  router.replace({
    name: "admin-buckets",
    query: queryParams,
  });
}

function deleteBucket(bucketName: string) {
  bucketRepository
    .deleteBucket(bucketName)
    .then(() => {
      bucketState.buckets = bucketState.buckets.filter(
        (bucket) => bucket.name !== bucketName,
      );
    })
    .finally(() => {
      bucketState.selectedBucket = undefined;
    });
}

function limitsUpdated(bucket: BucketOut) {
  const bucketIndex = bucketState.buckets.findIndex(
    (b) => b.name == bucket.name,
  );
  if (bucketIndex > -1) {
    bucketState.buckets[bucketIndex] = bucket;
  }
}

onBeforeMount(() => {
  let search = false;
  if (route.query[QUERY_PARAM_OWNER_ID] != undefined) {
    if (typeof route.query[QUERY_PARAM_OWNER_ID] === "string") {
      filters.ownerId = route.query[QUERY_PARAM_OWNER_ID];
      userRepository.fetchUsernames([route.query[QUERY_PARAM_OWNER_ID]]);
      search = true;
    }
  }
  if (route.query[QUERY_PARAM_BUCKET_NAME] != undefined) {
    if (typeof route.query[QUERY_PARAM_BUCKET_NAME] === "string") {
      filters.searchString = route.query[QUERY_PARAM_BUCKET_NAME];
      search = true;
    }
  }
  if (search) {
    searchBuckets();
  }
});
</script>

<template>
  <delete-bucket-modal
    modal-id="delete-bucket-modal"
    :bucket="bucketState.selectedBucket"
    @confirm-delete="deleteBucket"
  />
  <create-otr-modal
    modal-id="create-bucket-otr-modal"
    :target="
      bucketState.selectedBucket ?? {
        owner_id: '',
        created_at: 0,
        name: '',
        description: '',
        public: false,
      }
    "
  />
  <search-user-modal
    modal-id="admin-bucket-search-user-modal"
    @user-found="updateUser"
  />
  <update-bucket-limits-modal
    :bucket="bucketState.updateLimitsBucket"
    :modal-id="updateLimitsModalId"
    @updated-limits="limitsUpdated"
  />
  <div class="border-bottom mb-4">
    <h2>Manage Buckets</h2>
  </div>
  <form
    id="admin-bucket-search-form"
    @submit.prevent="searchBuckets"
    @reset.prevent="resetForm"
  >
    <div
      class="d-flex justify-content-evenly align-content-center mb-4 column-gap-2 flex-wrap"
    >
      <div class="flex-fill mx-2">
        <label for="admin-bucket-name-search" class="form-label"
          >Name of bucket</label
        >
        <div class="input-group">
          <div class="input-group-text">
            <font-awesome-icon icon="fa-solid fa-magnifying-glass" />
          </div>
          <input
            id="admin-bucket-name-search"
            v-model.trim="filters.searchString"
            type="search"
            class="form-control"
            placeholder="Search Buckets"
            maxlength="32"
          />
        </div>
      </div>
      <div class="flex-fill mx-2">
        <label for="admin-bucket-user-search" class="form-label"
          >Name of the owner</label
        >
        <div class="input-group">
          <div class="input-group-text">
            <font-awesome-icon icon="fa-solid fa-user" />
          </div>
          <input
            id="admin-bucket-user-search"
            type="text"
            class="form-control"
            readonly
            :value="nameRepository.getName(filters.ownerId)"
            placeholder="Search for owner"
            data-bs-toggle="modal"
            data-bs-target="#admin-bucket-search-user-modal"
          />
        </div>
      </div>
    </div>
    <button
      type="submit"
      class="btn btn-primary w-fit"
      :disabled="bucketState.loading"
    >
      Search
    </button>
    <button
      type="reset"
      class="btn-primary btn w-fit ms-4"
      :disabled="bucketState.loading"
    >
      Reset
    </button>
  </form>
  <div
    v-if="bucketState.buckets"
    class="overflow-x-auto"
    style="max-width: 100vw"
  >
    <table class="table table-striped align-middle">
      <thead>
        <tr>
          <th scope="col"><b>Name</b></th>
          <th scope="col">Description</th>
          <th scope="col">Created at</th>
          <th scope="col">Size Quota</th>
          <th scope="col">Object Quota</th>
          <th scope="col">Owner</th>
          <th scope="col"></th>
        </tr>
      </thead>
      <tbody v-if="filteredBuckets.length === 0">
        <tr>
          <td colspan="7" class="text-center fst-italic fw-light">
            <template v-if="bucketState.searched"
              >No bucket found with specified filters
            </template>
            <template v-else>Select a filter and search for buckets</template>
          </td>
        </tr>
      </tbody>
      <tbody v-else>
        <tr v-for="bucket in filteredBuckets" :key="bucket.name">
          <th scope="row">{{ bucket.name }}</th>
          <td class="description-column">{{ bucket.description }}</td>
          <td>
            {{ dayjs.unix(bucket.created_at).format("MMM DD, YYYY HH:mm:ss") }}
          </td>
          <td>
            <span v-if="bucket.size_limit">
              {{ filesize(1024 * bucket.size_limit) }}
            </span>
            <span v-else>-</span>
          </td>
          <td>
            <span v-if="bucket.object_limit">
              {{ bucket.object_limit }}
            </span>
            <span v-else>-</span>
          </td>
          <td>{{ nameRepository.getName(bucket.owner_id) }}</td>
          <td>
            <div
              class="btn-group btn-group-sm dropdown-center dropdown-menu-start"
            >
              <button
                type="button"
                class="btn btn-secondary btn-sm"
                data-bs-toggle="modal"
                :data-bs-target="'#' + updateLimitsModalId"
                @click="bucketState.updateLimitsBucket = bucket"
              >
                Edit quotas
              </button>
              <button
                type="button"
                class="btn btn-secondary dropdown-toggle dropdown-toggle-split"
                data-bs-toggle="dropdown"
                aria-expanded="false"
              >
                <span class="visually-hidden">Toggle Dropdown</span>
              </button>
              <ul class="dropdown-menu dropdown-menu">
                <li>
                  <button
                    class="dropdown-item"
                    type="button"
                    data-bs-toggle="modal"
                    data-bs-target="#create-bucket-otr-modal"
                    @click="bucketState.selectedBucket = bucket"
                  >
                    Transfer ownership
                  </button>
                </li>
                <li>
                  <button
                    class="dropdown-item text-danger align-middle"
                    type="button"
                    data-bs-toggle="modal"
                    data-bs-target="#delete-bucket-modal"
                    @click="bucketState.selectedBucket = bucket"
                  >
                    <font-awesome-icon icon="fa-solid fa-trash" />
                    <span class="ms-1">Delete</span>
                  </button>
                </li>
              </ul>
            </div>
          </td>
        </tr>
      </tbody>
    </table>
  </div>
</template>

<style scoped>
.description-column {
  word-break: break-all;
  max-width: 400px;
}
</style>
